"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RouteHandler = void 0;
var path_1 = __importDefault(require("path"));
var glob_1 = __importDefault(require("glob"));
var RouteHandler = /** @class */ (function () {
    function RouteHandler(folderLocation, app) {
        var _a;
        // @ts-ignore
        this.folder = path_1.default.resolve((_a = require.main) === null || _a === void 0 ? void 0 : _a.path, folderLocation);
        this.app = app;
        this.bindRoutes();
    }
    RouteHandler.prototype.createEndpoints = function (routes) {
        var _this = this;
        return routes.map(function (route) {
            return route
                .replace(_this.folder, '')
                .replace('index.ts', '')
                .replace('.ts', '')
                .replace(/\[[\w]+\]/g, function (match) { return ':' + match.replace(/[\[\]]/g, ''); });
        });
    };
    RouteHandler.prototype.bindRoutes = function () {
        var _this = this;
        glob_1.default(this.folder + "/**/[!_]*.ts", function (error, routes) {
            if (error)
                throw error;
            var endpoints = _this.createEndpoints(routes);
            routes.forEach(function (route, index) {
                var methods = require(route);
                var endpoint = endpoints[index];
                Object.keys(methods).forEach(function (method) {
                    // @ts-ignore
                    _this.app[method.toLowerCase()](endpoint, methods[method]);
                });
            });
        });
    };
    return RouteHandler;
}());
exports.RouteHandler = RouteHandler;
exports.default = RouteHandler;
